From ef053909930c648e1c3c0be56f29e31439c2fd38 Mon Sep 17 00:00:00 2001
From: Jiajin Cui <cuijiajin@uniontech.com>
Date: Sun, 28 Jun 2020 13:18:55 +0800
Subject: [PATCH] qcap: Fix always wait for ReadThread to end when fiter_Stop.

There is a very small probability that the ReadThread will always wait for run_event signal after filet_Stop calls qcap_driver_stop_stream, and then filter_Stop is stuck waiting for the ReadThread to exit when calling qcap_driver_cleanup_stream. This issue was found in the video call hang up of Tencent QQ application.

Signed-off-by: Jiajin Cui <cuijiajin@uniontech.com>
---
 dlls/qcap/v4l.c | 1 +
 1 file changed, 1 insertion(+)

diff --git a/dlls/qcap/v4l.c b/dlls/qcap/v4l.c
index 449951ad53..d695f2e52e 100644
--- a/dlls/qcap/v4l.c
+++ b/dlls/qcap/v4l.c
@@ -427,6 +427,7 @@ void qcap_driver_cleanup_stream(Capture *device)
     HRESULT hr;
 
     device->state = State_Stopped;
+    SetEvent(device->run_event);
     WaitForSingleObject(device->thread, INFINITE);
     CloseHandle(device->thread);
     device->thread = NULL;
-- 
2.20.1

